=== added file 'src/com/goldencode/p2j/ui/client/layout/GridLayout.java'
--- src/com/goldencode/p2j/ui/client/layout/GridLayout.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/client/layout/GridLayout.java	2020-02-11 08:31:45 +0000
@@ -0,0 +1,193 @@
+/*
+** Module   : GridLayout.java
+** Abstract : Simple grid layout manager. 
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------Description----------------------------------
+** 001 SBI 20200210 Created initial version
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.ui.client.layout;
+
+import com.goldencode.p2j.ui.*;
+import com.goldencode.p2j.ui.client.*;
+import com.goldencode.p2j.ui.client.gui.*;
+import com.goldencode.p2j.ui.client.widget.*;
+
+/**
+ * Simple implementation of grid layout.
+ */
+public class GridLayout<O extends OutputManager<?>>
+implements LayoutManager<O>
+{
+   /** The number of columns */
+   private final int columns;
+   
+   /** The number of rows */
+   private final int rows;
+   
+   /**
+    * Takes the visible number of columns and rows to align widgets within their container
+    * 
+    * @param    columns
+    *           The number of columns
+    * @param    rows
+    *           The number of rows
+    * 
+    */
+   public GridLayout(int columns, int rows)
+   {
+      this.columns = columns;
+      this.rows = rows;
+   }
+
+   /**
+    * Calculate minimum space required for contained widgets.
+    * 
+    * @param    container
+    *           Container to process.
+    * 
+    * @return   calculated dimension.
+    */
+   @Override
+   public Dimension minimumSize(Container<O> container)
+   {
+      double width = 0;
+      double height = 0;
+
+      Widget<O> innerPane = container.get(0);
+      
+      if (innerPane != null)
+      {
+         Dimension inner = innerPane.minimumSize();
+         height = inner.height;
+         width = inner.width;
+      }
+      
+      Insets insets = container.insets();
+      
+      height = Coordinate.scale(height + insets.heightDelta());
+      width = Coordinate.scale(width + insets.widthDelta());
+
+      return new Dimension(width, height);
+   }
+
+   /**
+    * Process container and place components at required locations.
+    * 
+    * @param    container
+    *           Container to process.
+    */
+   @Override
+   public void doLayout(Container<O> container)
+   {
+      Widget<O>[] widgets = container.widgets();
+      
+      Dimension size = container.dimension();
+      Insets insets = container.insets();
+
+      double availWidth = size.width - insets.widthDelta();
+      double availHeight = size.height - insets.heightDelta();
+      
+      // BorderedPanelGuiImpl already takes care of translating the insets for its children,
+      // so for the children of BorderedPanelGuiImpl the origin is relative to the parent's
+      // origin plus the insets
+      Point loc = container instanceof BorderedPanelGuiImpl ? new Point(0, 0) : 
+                                                              new Point(insets.left, insets.top);
+      
+      double widthCell = availWidth / columns;
+      
+      double heightCell = availHeight / rows;
+      
+      int col = 1;
+      int row = 1;
+      double shiftCol = 0;
+      double shiftRow = 0;
+      int num = widgets.length;
+      
+      for(int i = 0; i < num; i++)
+      {
+         Widget<O> widget = widgets[i];
+         Dimension dim = widget.dimension();
+         
+         double x = loc.x + (widthCell - dim.width) / 2 + shiftCol;
+         
+         double y = loc.y + (heightCell - dim.height) / 2 + shiftRow;
+         
+         widget.setLocation(x, y);
+         
+         if (col == columns)
+         {
+            if (row < rows)
+            {
+               row++;
+               shiftRow += heightCell;
+            }
+            else
+            {
+               break;
+            }
+            col = 1;
+            shiftCol = 0;
+         }
+         else
+         {
+            col++;
+            shiftCol += widthCell;
+         }
+      }
+   }
+}

=== modified file 'src/com/goldencode/p2j/ui/client/widget/AbstractWidget.java'
--- src/com/goldencode/p2j/ui/client/widget/AbstractWidget.java	2019-12-18 22:26:05 +0000
+++ src/com/goldencode/p2j/ui/client/widget/AbstractWidget.java	2020-02-25 16:38:15 +0000
@@ -152,6 +152,7 @@
 **                  For selectable widgets process only key events for navigation keys.
 ** 085 HC  20191210 Improved emulation of setFocus Win32 system function.
 **     HC  20191218 Added the support for a notification when widget ancestor changes.
+** 086 SBI 20200225 Added getTextHeightNative.
 */
 
 /*
@@ -2682,6 +2683,55 @@
    }
    
    /**
+    * Compute the text height using {@link GuiDriver#getTextHeight}.
+    *
+    * @param    txt
+    *           The text.
+    * @param    font
+    *           The font details.
+    *
+    * @return   The text height.
+    */
+   public int getTextHeightNative(String txt, FontDetails font)
+   {
+      TitledWindow<O> topWindow = ancestor();
+      Window<O> window = null;
+      if (topWindow == null)
+      {
+         // check if it's frame-id is set - if so, use that
+         if (config().frameId != -1)
+         {
+            Widget<?> parent = ThinClient.getInstance().getWidget(config().frameId);
+            topWindow = window = (Window<O>) parent.window();
+         }
+         else
+         {
+            // fallback to default-window
+            topWindow = window = WindowManager.getDefaultWindow();
+         }
+      }
+      else if (topWindow instanceof TopLevelWindow)
+      {
+         window = topWindow.window();
+      }
+      else
+      {
+         window = window();
+      }
+      
+      GuiDriver gd = (GuiDriver) screen().getInstanceDriver();
+      gd.selectWindow(UiUtils.getWidgetIdAsInt(topWindow));
+      try
+      {
+         return gd.getTextHeight(txt, font);
+      }
+      finally
+      {
+         gd.releaseWindow();
+      }
+   }
+   
+   /**
     * Compute the text width using {@link FontManager#getTextWidth}.
     * 
     * @param    txt

=== modified file 'src/com/goldencode/p2j/util/HandleCommon.java'
--- src/com/goldencode/p2j/util/HandleCommon.java	2019-11-19 14:11:39 +0000
+++ src/com/goldencode/p2j/util/HandleCommon.java	2020-02-25 16:42:23 +0000
@@ -3,7 +3,7 @@
 ** Abstract : A massive interface which groups together all attributes and methods available
 **            via a handle.
 **
-** Copyright (c) 2013-2019, Golden Code Development Corporation.
+** Copyright (c) 2013-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------Description----------------------------------
 ** 001 CA  20130112 Created initial version.
@@ -67,6 +67,7 @@
 **     OM  20190721 Added DataRelationInterface, and DataSourceInterface.
 ** 049 HC  20190614 Initial implementation of IMAGELIST widget.
 ** 050 MAG 20190920 Added ProgressBar interface.
+** 051 SBI 20200225 Added Calendar widget support.
 */
 
 /*
@@ -242,6 +243,7 @@
         
         // FWD extension interfaces are listed from this point forward
         CustomFont,
+        Calendar,
         EmailSender,
         FWDTimer,
         HtmlBrowser,

=== modified file 'src/com/goldencode/p2j/util/LegacyResource.java'
--- src/com/goldencode/p2j/util/LegacyResource.java	2020-01-29 14:38:53 +0000
+++ src/com/goldencode/p2j/util/LegacyResource.java	2020-02-25 16:36:49 +0000
@@ -2,7 +2,7 @@
 ** Module   : LegacyResource.java
 ** Abstract : Annotation definition for a legacy resource.
 **
-** Copyright (c) 2013-2019, Golden Code Development Corporation.
+** Copyright (c) 2013-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------Description-----------------------------------
 ** 001 CA  20130926 Created initial version.
@@ -21,6 +21,7 @@
 ** 009 OM  20190411 Added constants for DataSet related resources.
 ** 010 HC  20190614 Initial implementation of IMAGELIST widget.
 ** 011 MAG 20190919 Added constants for PROGRESS-BAR widget.
+** 012 SBI 20200225 Added Calendar widget support.
 */
 
 /*
@@ -192,6 +193,9 @@
    /** Constant identifying the DIALOG-BOX resource. */
    public static String DIALOG_BOX = "DIALOG-BOX";
 
+   /** Constant identifying the CALENDAR resource. */
+   public static String CALENDAR = "CALENDAR";
+
    /** Constant identifying the  resource. */
    public static String EDITOR = "EDITOR";
 

=== modified file 'src/com/goldencode/p2j/util/Utils.java'
--- src/com/goldencode/p2j/util/Utils.java	2020-01-30 20:08:18 +0000
+++ src/com/goldencode/p2j/util/Utils.java	2020-02-25 16:35:33 +0000
@@ -144,6 +144,7 @@
 **     CA  20191212          Added findConstructor, to find the first ctor which matches the 
 **                           argument's class or super-class, or any of its super-interfaces.
 ** 069 HC  20200130          Added a method for enumerating nodes.
+** 070 SBI 20200225          Moved isValidValue to this helper class.
 */
 
 /*
@@ -3756,6 +3757,30 @@
    }
    
    /**
+    * Check if a given value is a valid value.
+    * 
+    * @param    value
+    *           Value to check.
+    * @param    validValues
+    *           List of valid values.
+    *          
+    * @return   <code>true</code> if value is in the list of valid values,
+    *           otherwise <code>false</code>.
+    */
+   public static boolean isValidValue(int value, int ... validValues)
+   {
+      for (int v : validValues)
+      {
+         if (value == v)
+         {
+            return true;
+         }
+      }
+      
+      return false;
+   }
+   
+   /**
     * Determines whether two sets have common elements.
     * 
     * @param <T> 

=== modified file 'src/com/goldencode/p2j/util/handle.java'
--- src/com/goldencode/p2j/util/handle.java	2020-01-21 14:39:51 +0000
+++ src/com/goldencode/p2j/util/handle.java	2020-02-25 16:33:41 +0000
@@ -2,7 +2,7 @@
 ** Module   : handle.java
 ** Abstract : Progress 4GL compatible handle object
 **
-** Copyright (c) 2005-2019, Golden Code Development Corporation.
+** Copyright (c) 2005-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --JPRM-- -----------------------------Description-----------------------------
 ** 001 GES 20051125   @23505 Created initial version which represents
@@ -207,6 +207,7 @@
 ** 114 HC  20190614          Initial implementation of IMAGELIST widget.
 **                           assigned to a handle output argument.
 ** 115 MAG 20190920          Added PROGRESS-BAR support.
+** 116 SBI 20200225          Added Calendar widget support.
 */
 
 /*
@@ -268,12 +269,15 @@
 import java.lang.reflect.*;
 import java.util.*;
 import java.util.logging.*;
+
 import com.goldencode.p2j.extension.*;
 import com.goldencode.p2j.email.*;
 import com.goldencode.p2j.persist.*;
 import com.goldencode.p2j.reporting.*;
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.ui.*;
+/** Calendar must be imported explicitly */ 
+import com.goldencode.p2j.ui.Calendar;
 import com.goldencode.p2j.xml.*;
 import com.goldencode.proxy.*;
 
@@ -2781,6 +2785,16 @@
    }
 
    /**
+    * Unwrap this handle to the calendar widget interface.
+    * 
+    * @return   The calendar widget interface
+    */
+   public Calendar unwrapCalendar()
+   {
+      return unwrapImpl(this, Calendar.class);
+   }
+
+   /**
     * Unwrap this handle to a {@link DeblankInterface} instance. If the
     * handle is not a widget handle or is invalid, an 
     * {@link #invalidAttrAccessProxy dynamic proxy} is returned.
@@ -3293,7 +3307,17 @@
    {
       return unwrapImpl(this, ImageList.class);
    }
-
+   
+   /**
+    * Gets the instance of WidgetExtension.
+    * 
+    * @return   The instance of WidgetExtension
+    */
+   public WidgetExtension unwrapWidgetExtension()
+   {
+      return unwrapImpl(this, WidgetExtension.class);
+   }
+   
    /**
     * Creates a new instance of the same type that represents the 
     * <code>unknown value</code>.

